<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- XSLT for SCARF xml output -->
	<xsl:template match="/rules">
		<html><head>
			<title>SCARF output</title>
			<style type="text/css">
			
h1 {
	font-family: sans-serif;
	font-size: 16pt;
}

h2 {
	font-family: sans-serif;
	font-size: 14pt;
}

div.rule {
	background-color: #ffc;
	border-style: solid;
	border-color: #ddd;
	border-width: 1px;
	width: 700px;
	margin-left: 10px;
	margin-top: 10px;
	margin-right: 10px;
	margin-bottom: 20px;
	padding: 10px;
}

div.expression {
	background-color: white;
	border-style: solid;
	border-color: #ddd;
	border-width: 1px;
	margin-bottom: 10px;
	font-family: monospace;
	font-size: 12pt;
}

span.variable {
}

span.and_clause {
}

span.or_clause {
}

span.implies_clause {
}

span.operator_and:after {
	content: &quot; &amp; &quot;;
}

span.operator_or:after {
	content: &quot; OR &quot;;
}

span.operator_implies:after {
	content: &quot; &#x21D2; &quot;;
}

td.stats_key {
	font-family: sans-serif;
	font-size: 10pt;
	font-weight: bold;
	color: maroon;
}

td.stats_value {
	font-family: monospace;
	font-size: 10pt;
}

span.stats_universe:after { content: &quot;Universe&quot;; }
span.stats_lhs_support:after { content: &quot;LHS support&quot;; }
span.stats_rhs_support:after { content: &quot;RHS support&quot;; }
span.stats_support:after { content: &quot;Support&quot;; }
span.stats_confidence:after { content: &quot;Confidence&quot;; }
span.stats_lift:after { content: &quot;Lift&quot;; }
span.stats_leverage:after { content: &quot;Leverage&quot;; }
span.stats_p_value:after { content: &quot;p-value&quot;; }
span.stats_e_value:after { content: &quot;E-value&quot;; }
			</style>
		</head><body>
			<h1>The following rules were found:</h1>
			<xsl:apply-templates select="*"/>
		</body></html>
	</xsl:template>
	
	<xsl:template match="rule">
		<h2>Rule #<xsl:value-of select="1+count(preceding-sibling::*[name()=name(current())])"/></h2>
		<div class="rule">
			<xsl:apply-templates select="*"/>
		</div>
	</xsl:template>
	
	<xsl:template match="expression">
		<div class="expression">
			<xsl:apply-templates select="*"/>
		</div>
	</xsl:template>
	
	<xsl:template match="and">
		<span class="and_clause">
			<xsl:for-each select="*">
				<xsl:apply-templates select="."/>
				<xsl:if test="position()!=last()">
					<span class="operator_and"/>
				</xsl:if>
			</xsl:for-each>
		</span>
	</xsl:template>

	<xsl:template match="or">
		<span class="or_clause">
			<xsl:if test="*[2]">
			(
			</xsl:if>
			<xsl:for-each select="*">
				<xsl:apply-templates select="."/>
				<xsl:if test="position()!=last()">
					<span class="operator_or"/>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="*[2]">
			)
			</xsl:if>
		</span>
	</xsl:template>
	
	<xsl:template match="implies">
		<span class="implies_clause">
			<xsl:for-each select="*">
				<xsl:apply-templates select="."/>
				<xsl:if test="position()!=last()">
					<span class="operator_implies"/>
				</xsl:if>
			</xsl:for-each>
		</span>
	</xsl:template>
	
	<xsl:template match="variable">
		<span class="variable">
			<xsl:value-of select="."/>
		</span>
	</xsl:template>
	
	<xsl:template match="stats">
		<table>
			<xsl:for-each select="*">
				<tr>
					<td class="stats_key">
						<span><xsl:attribute name="class">stats_<xsl:value-of select="local-name()"/></xsl:attribute></span>:
					</td>
					<td class="stats_value">
						<xsl:value-of select="."/>
					</td>
				</tr>
			</xsl:for-each>
		</table>
	</xsl:template>
</xsl:stylesheet>
